Index: sys/kern/uipc_socket.c
===================================================================
--- sys/kern/uipc_socket.c	(revision 312784)
+++ sys/kern/uipc_socket.c	(working copy)
@@ -106,6 +106,7 @@ __FBSDID("$FreeBSD$");
 #include "opt_inet.h"
 #include "opt_inet6.h"
 #include "opt_compat.h"
+#include "opt_sctp.h"
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -159,14 +160,17 @@ static void	filt_sordetach(struct knote *kn);
 static int	filt_soread(struct knote *kn, long hint);
 static void	filt_sowdetach(struct knote *kn);
 static int	filt_sowrite(struct knote *kn, long hint);
+static int	filt_soempty(struct knote *kn, long hint);
 static int	filt_solisten(struct knote *kn, long hint);
+static void	filt_soldetach(struct knote *kn);
 static int inline hhook_run_socket(struct socket *so, void *hctx, int32_t h_id);
-static int	filt_soempty(struct knote *kn, long hint);
+
 fo_kqfilter_t	soo_kqfilter;
+fo_kqfilter_t	sol_kqfilter;
 
 static struct filterops solisten_filtops = {
 	.f_isfd = 1,
-	.f_detach = filt_sordetach,
+	.f_detach = filt_soldetach,
 	.f_event = filt_solisten,
 };
 static struct filterops soread_filtops = {
@@ -187,6 +191,7 @@ static struct filterops soempty_filtops = {
 
 so_gen_t	so_gencnt;	/* generation count for sockets */
 
+MALLOC_DEFINE(M_SOLISTEN, "solisten", "listening sockets");
 MALLOC_DEFINE(M_SONAME, "soname", "socket name");
 MALLOC_DEFINE(M_PCB, "pcb", "protocol control block");
 
@@ -439,7 +444,6 @@ sodealloc(struct socket *so)
 {
 
 	KASSERT(so->so_count == 0, ("sodealloc(): so_count %d", so->so_count));
-	KASSERT(so->so_pcb == NULL, ("sodealloc(): so_pcb != NULL"));
 
 	mtx_lock(&so_global_mtx);
 	so->so_gencnt = ++so_gencnt;
@@ -456,9 +460,6 @@ sodealloc(struct socket *so)
 	if (so->so_snd.sb_hiwat)
 		(void)chgsbsize(so->so_cred->cr_uidinfo,
 		    &so->so_snd.sb_hiwat, 0, RLIM_INFINITY);
-	/* remove accept filter if one is present. */
-	if (so->so_accf != NULL)
-		do_setopt_accept_filter(so, NULL);
 #ifdef MAC
 	mac_socket_destroy(so);
 #endif
@@ -512,8 +513,6 @@ socreate(int dom, struct socket **aso, int type, i
 	if (so == NULL)
 		return (ENOBUFS);
 
-	TAILQ_INIT(&so->so_incomp);
-	TAILQ_INIT(&so->so_comp);
 	so->so_type = type;
 	so->so_cred = crhold(cred);
 	if ((prp->pr_domain->dom_family == PF_INET) ||
@@ -563,7 +562,7 @@ SYSCTL_INT(_regression, OID_AUTO, sonewconn_earlyt
  * Note: the ref count on the socket is 0 on return.
  */
 struct socket *
-sonewconn(struct socket *head, int connstatus)
+sonewconn(struct solisten *sol, int connstatus)
 {
 	static struct timeval lastover;
 	static struct timeval overinterval = { 60, 0 };
@@ -570,11 +569,11 @@ struct socket *
 	static int overcount;
 
 	struct socket *so;
-	int over;
+	u_int over;
 
-	ACCEPT_LOCK();
-	over = (head->so_qlen > 3 * head->so_qlimit / 2);
-	ACCEPT_UNLOCK();
+	SOLISTEN_LOCK(sol);
+	over = (sol->sol_qlen > 3 * sol->sol_qlimit / 2);
+	SOLISTEN_UNLOCK(sol);
 #ifdef REGRESSION
 	if (regression_sonewconn_earlytest && over) {
 #else
@@ -586,7 +585,7 @@ struct socket *
 			log(LOG_DEBUG, "%s: pcb %p: Listen queue overflow: "
 			    "%i already in queue awaiting acceptance "
 			    "(%d occurrences)\n",
-			    __func__, head->so_pcb, head->so_qlen, overcount);
+			    __func__, sol->sol_pcb, sol->sol_qlen, overcount);
 
 			overcount = 0;
 		}
@@ -593,69 +592,57 @@ struct socket *
 
 		return (NULL);
 	}
-	VNET_ASSERT(head->so_vnet != NULL, ("%s:%d so_vnet is NULL, head=%p",
-	    __func__, __LINE__, head));
-	so = soalloc(head->so_vnet);
+	VNET_ASSERT(sol->sol_vnet != NULL, ("%s: sol %p vnet is NULL",
+	    __func__, sol));
+	so = soalloc(sol->sol_vnet);
 	if (so == NULL) {
 		log(LOG_DEBUG, "%s: pcb %p: New socket allocation failure: "
 		    "limit reached or out of memory\n",
-		    __func__, head->so_pcb);
+		    __func__, sol->sol_pcb);
 		return (NULL);
 	}
-	if ((head->so_options & SO_ACCEPTFILTER) != 0)
+	if (sol->sol_accept_filter != NULL)
 		connstatus = 0;
-	so->so_head = head;
-	so->so_type = head->so_type;
-	so->so_options = head->so_options &~ SO_ACCEPTCONN;
-	so->so_linger = head->so_linger;
-	so->so_state = head->so_state | SS_NOFDREF;
-	so->so_fibnum = head->so_fibnum;
-	so->so_proto = head->so_proto;
-	so->so_cred = crhold(head->so_cred);
+	so->so_listen = sol;
+	so->so_type = sol->sol_type;
+	so->so_options = sol->sol_options;
+	so->so_linger = sol->sol_linger;
+	so->so_state = sol->sol_state | SS_NOFDREF;
+	so->so_fibnum = sol->sol_fibnum;
+	so->so_proto = sol->sol_proto;
+	so->so_cred = crhold(sol->sol_cred);
 #ifdef MAC
-	mac_socket_newconn(head, so);
+	QQQ
+	mac_socket_newconn(sol, so);
 #endif
 	knlist_init_mtx(&so->so_rcv.sb_sel.si_note, SOCKBUF_MTX(&so->so_rcv));
 	knlist_init_mtx(&so->so_snd.sb_sel.si_note, SOCKBUF_MTX(&so->so_snd));
-	VNET_SO_ASSERT(head);
-	if (soreserve(so, head->so_snd.sb_hiwat, head->so_rcv.sb_hiwat)) {
+	VNET_SO_ASSERT(sol);
+	if (soreserve(so, sol->sol_sbsnd_hiwat, sol->sol_sbrcv_hiwat)) {
 		sodealloc(so);
 		log(LOG_DEBUG, "%s: pcb %p: soreserve() failed\n",
-		    __func__, head->so_pcb);
+		    __func__, sol->sol_pcb);
 		return (NULL);
 	}
 	if ((*so->so_proto->pr_usrreqs->pru_attach)(so, 0, NULL)) {
 		sodealloc(so);
 		log(LOG_DEBUG, "%s: pcb %p: pru_attach() failed\n",
-		    __func__, head->so_pcb);
+		    __func__, sol->sol_pcb);
 		return (NULL);
 	}
-	so->so_rcv.sb_lowat = head->so_rcv.sb_lowat;
-	so->so_snd.sb_lowat = head->so_snd.sb_lowat;
-	so->so_rcv.sb_timeo = head->so_rcv.sb_timeo;
-	so->so_snd.sb_timeo = head->so_snd.sb_timeo;
-	so->so_rcv.sb_flags |= head->so_rcv.sb_flags & SB_AUTOSIZE;
-	so->so_snd.sb_flags |= head->so_snd.sb_flags & SB_AUTOSIZE;
+	so->so_rcv.sb_lowat = sol->sol_sbrcv_lowat;
+	so->so_snd.sb_lowat = sol->sol_sbsnd_lowat;
+	so->so_rcv.sb_timeo = sol->sol_sbrcv_timeo;
+	so->so_snd.sb_timeo = sol->sol_sbsnd_timeo;
+	so->so_rcv.sb_flags |= sol->sol_sbrcv_flags & SB_AUTOSIZE;
+	so->so_snd.sb_flags |= sol->sol_sbsnd_flags & SB_AUTOSIZE;
 	so->so_state |= connstatus;
-	ACCEPT_LOCK();
-	/*
-	 * The accept socket may be tearing down but we just
-	 * won a race on the ACCEPT_LOCK.
-	 * However, if sctp_peeloff() is called on a 1-to-many
-	 * style socket, the SO_ACCEPTCONN doesn't need to be set.
-	 */
-	if (!(head->so_options & SO_ACCEPTCONN) &&
-	    ((head->so_proto->pr_protocol != IPPROTO_SCTP) ||
-	     (head->so_type != SOCK_SEQPACKET))) {
-		SOCK_LOCK(so);
-		so->so_head = NULL;
-		sofree(so);		/* NB: returns ACCEPT_UNLOCK'ed. */
-		return (NULL);
-	}
+
+	SOLISTEN_LOCK(sol);
 	if (connstatus) {
-		TAILQ_INSERT_TAIL(&head->so_comp, so, so_list);
+		TAILQ_INSERT_TAIL(&sol->sol_comp, so, so_list);
 		so->so_qstate |= SQ_COMP;
-		head->so_qlen++;
+		sol->sol_qlen++;
 	} else {
 		/*
 		 * Keep removing sockets from the head until there's room for
@@ -664,29 +651,90 @@ struct socket *
 		 * threads and soabort() requires dropping locks, we must
 		 * loop waiting for the condition to be true.
 		 */
-		while (head->so_incqlen > head->so_qlimit) {
+		while (sol->sol_incqlen > sol->sol_qlimit) {
 			struct socket *sp;
-			sp = TAILQ_FIRST(&head->so_incomp);
-			TAILQ_REMOVE(&head->so_incomp, sp, so_list);
-			head->so_incqlen--;
+			sp = TAILQ_FIRST(&sol->sol_incomp);
+			TAILQ_REMOVE(&sol->sol_incomp, sp, so_list);
+			sol->sol_incqlen--;
 			sp->so_qstate &= ~SQ_INCOMP;
-			sp->so_head = NULL;
-			ACCEPT_UNLOCK();
+			sp->so_listen = NULL;
+			SOLISTEN_UNLOCK(sol);
 			soabort(sp);
-			ACCEPT_LOCK();
+			SOLISTEN_LOCK(sol);
 		}
-		TAILQ_INSERT_TAIL(&head->so_incomp, so, so_list);
+		TAILQ_INSERT_TAIL(&sol->sol_incomp, so, so_list);
 		so->so_qstate |= SQ_INCOMP;
-		head->so_incqlen++;
+		sol->sol_incqlen++;
 	}
-	ACCEPT_UNLOCK();
+	SOLISTEN_UNLOCK(sol);
 	if (connstatus) {
-		sorwakeup(head);
-		wakeup_one(&head->so_timeo);
+		/* QQQ sorwakeup(head); */
+		selwakeuppri(&sol->sol_selinfo, PSOCK);
+		KNOTE_LOCKED(&sol->sol_selinfo.si_note, 0);
+		wakeup_one(&sol->sol_comp);
 	}
 	return (so);
 }
 
+#ifdef SCTP
+/*
+ * Socket part of sctp_peeloff().  Detach a new socket from an
+ * association.  The new socket is returned with a reference.
+ */
+struct socket *
+sopeeloff(struct socket *head)
+{
+	struct socket *so;
+
+	VNET_ASSERT(head->so_vnet != NULL, ("%s:%d so_vnet is NULL, head=%p",
+	    __func__, __LINE__, head));
+	so = soalloc(head->so_vnet);
+	if (so == NULL) {
+		log(LOG_DEBUG, "%s: pcb %p: New socket allocation failure: "
+		    "limit reached or out of memory\n",
+		    __func__, head->so_pcb);
+		return (NULL);
+	}
+	so->so_type = head->so_type;
+	so->so_options = head->so_options;
+	so->so_linger = head->so_linger;
+	so->so_state = (head->so_state & SS_NBIO) | SS_ISCONNECTED;
+	so->so_fibnum = head->so_fibnum;
+	so->so_proto = head->so_proto;
+	so->so_cred = crhold(head->so_cred);
+#ifdef MAC
+	mac_socket_newconn(head, so);
+#endif
+	knlist_init_mtx(&so->so_rcv.sb_sel.si_note, SOCKBUF_MTX(&so->so_rcv));
+	knlist_init_mtx(&so->so_snd.sb_sel.si_note, SOCKBUF_MTX(&so->so_snd));
+	VNET_SO_ASSERT(head);
+	if (soreserve(so, head->so_snd.sb_hiwat, head->so_rcv.sb_hiwat)) {
+		sodealloc(so);
+		log(LOG_DEBUG, "%s: pcb %p: soreserve() failed\n",
+		    __func__, head->so_pcb);
+		return (NULL);
+	}
+	if ((*so->so_proto->pr_usrreqs->pru_attach)(so, 0, NULL)) {
+		sodealloc(so);
+		log(LOG_DEBUG, "%s: pcb %p: pru_attach() failed\n",
+		    __func__, head->so_pcb);
+		return (NULL);
+	}
+	so->so_rcv.sb_lowat = head->so_rcv.sb_lowat;
+	so->so_snd.sb_lowat = head->so_snd.sb_lowat;
+	so->so_rcv.sb_timeo = head->so_rcv.sb_timeo;
+	so->so_snd.sb_timeo = head->so_snd.sb_timeo;
+	so->so_rcv.sb_flags |= head->so_rcv.sb_flags & SB_AUTOSIZE;
+	so->so_snd.sb_flags |= head->so_snd.sb_flags & SB_AUTOSIZE;
+
+	SOCK_LOCK(so);
+	soref(so);
+	SOCK_UNLOCK(so);
+
+	return (so);
+}
+#endif	/* SCTP */
+
 int
 sobind(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
@@ -711,49 +759,128 @@ sobindat(int fd, struct socket *so, struct sockadd
 
 /*
  * solisten() transitions a socket from a non-listening state to a listening
- * state, but can also be used to update the listen queue depth on an
- * existing listen socket.  The protocol will call back into the sockets
- * layer using solisten_proto_check() and solisten_proto() to check and set
- * socket-layer listen state.  Call backs are used so that the protocol can
- * acquire both protocol and socket layer locks in whatever order is required
- * by the protocol.
- *
- * Protocol implementors are advised to hold the socket lock across the
- * socket-layer test and set to avoid races at the socket layer.
+ * state.
  */
 int
-solisten(struct socket *so, int backlog, struct thread *td)
+solisten(struct socket *so, int backlog, struct thread *td, struct file *fp)
 {
+	struct solisten *sol;
 	int error;
 
 	CURVNET_SET(so->so_vnet);
-	error = (*so->so_proto->pr_usrreqs->pru_listen)(so, backlog, td);
-	CURVNET_RESTORE();
-	return (error);
-}
 
-int
-solisten_proto_check(struct socket *so)
-{
+	sol = malloc(sizeof(struct solisten), M_SOLISTEN, M_WAITOK | M_ZERO);
 
-	SOCK_LOCK_ASSERT(so);
-
+	SOCK_LOCK(so);
 	if (so->so_state & (SS_ISCONNECTED | SS_ISCONNECTING |
-	    SS_ISDISCONNECTING))
+	    SS_ISDISCONNECTING)) {
+		SOCK_UNLOCK(so);
+		free(sol, M_SOLISTEN);
 		return (EINVAL);
+	}
+	/*
+	 * XXXGL: we are going to drop socket lock, to avoid LOR
+	 * against protocol locks, thus to block any other syscalls
+	 * on the socket we mark it SS_ISDISCONNECTING.
+	 * If that doesn't work well, we would need a separate flag
+	 * to mark the fact that socket is now under listen(2)
+	 * transmutation.
+	 */
+	so->so_state |= SS_ISDISCONNECTING;
+	SOCK_UNLOCK(so);
+
+	sol->sol_type = so->so_type;
+	sol->sol_options = so->so_options;
+	sol->sol_linger = so->so_linger;
+	sol->sol_state = so->so_state & ~SS_ISDISCONNECTING;
+	sol->sol_fibnum = so->so_fibnum;
+	sol->sol_sbrcv_lowat = so->so_rcv.sb_lowat;
+	sol->sol_sbsnd_lowat = so->so_snd.sb_lowat;
+	sol->sol_sbrcv_hiwat = so->so_rcv.sb_hiwat;
+	sol->sol_sbsnd_hiwat = so->so_snd.sb_hiwat;
+	sol->sol_sbrcv_flags = so->so_rcv.sb_flags;
+	sol->sol_sbsnd_flags = so->so_snd.sb_flags;
+	sol->sol_sbrcv_timeo = so->so_rcv.sb_timeo;
+	sol->sol_sbsnd_timeo = so->so_snd.sb_timeo;
+	sol->sol_proto = so->so_proto;
+	sol->sol_vnet = so->so_vnet;
+	sol->sol_cred = so->so_cred;
+	if (so->so_sigio != NULL)
+		fsetown(fgetown(&so->so_sigio), &sol->sol_sigio);
+	else
+		sol->sol_sigio = NULL;
+	sol->sol_pcb = so->so_pcb;
+	sol->sol_accept_filter = NULL;
+	sol->sol_accept_filter_arg = NULL;
+	sol->sol_accept_filter_str = NULL;
+	sol->sol_error = 0;
+
+	mtx_init(&sol->sol_mutex, "solisten", NULL, MTX_DEF);
+	knlist_init_mtx(&sol->sol_selinfo.si_note, &sol->sol_mutex);
+	sol->sol_qlen = sol->sol_incqlen = 0;
+	if (backlog < 0 || backlog > somaxconn)
+		backlog = somaxconn;
+	sol->sol_qlimit = backlog;
+	TAILQ_INIT(&sol->sol_incomp);
+	TAILQ_INIT(&sol->sol_comp);
+
+	error = (*so->so_proto->pr_usrreqs->pru_listen)(so, sol, backlog, td);
+	if (error) {
+		SOCK_LOCK(so);
+		so->so_state &= ~SS_ISDISCONNECTING;
+		SOCK_UNLOCK(so);
+		funsetown(&sol->sol_sigio);
+		knlist_destroy(&sol->sol_selinfo.si_note);
+		mtx_destroy(&sol->sol_mutex);
+		free(sol, M_SOLISTEN);
+		return (error);
+	}
+
+	finit(fp, fp->f_flag, DTYPE_SOLISTEN, sol, &solistenops);
+
+	SOCK_LOCK(so);
+	KASSERT((so->so_state & SS_NOFDREF) == 0, ("%s: NOFDREF", __func__));
+	funsetown(&so->so_sigio);
+	so->so_state |= SS_NOFDREF;
+	so->so_pcb = NULL;
+	sorele(so);
+
+	CURVNET_RESTORE();
+
 	return (0);
 }
 
-void
-solisten_proto(struct socket *so, int backlog)
+/*
+ * sollisten() implements listen(2) on already listening socket.  For most
+ * protocols it just updates backlog length, but for SCTP it unlistens the
+ * socket.
+ */
+int
+sollisten(struct solisten *sol, int backlog, struct thread *td, struct file *fp)
 {
+	int error;
 
-	SOCK_LOCK_ASSERT(so);
+	error = (*sol->sol_proto->pr_usrreqs->pru_listen)(NULL,
+	    sol, backlog, td);
 
+	/*
+	 * If the protocol decides to do something more complex than backlog
+	 * update, it does all the work itself and returns ENOTSOCK.  For now
+	 * this is case only for SCTP.
+	 */
+	if (error == ENOTSOCK)
+		return (0);
+
+	if (error)
+		return (error);
+
 	if (backlog < 0 || backlog > somaxconn)
 		backlog = somaxconn;
-	so->so_qlimit = backlog;
-	so->so_options |= SO_ACCEPTCONN;
+	SOLISTEN_LOCK(sol);
+	sol->sol_qlimit = backlog;
+	SOLISTEN_UNLOCK(sol);
+
+	return (0);
 }
 
 /*
@@ -780,52 +907,54 @@ void
 sofree(struct socket *so)
 {
 	struct protosw *pr = so->so_proto;
-	struct socket *head;
+	struct solisten *sol;
 
-	ACCEPT_LOCK_ASSERT();
 	SOCK_LOCK_ASSERT(so);
 
 	if ((so->so_state & SS_NOFDREF) == 0 || so->so_count != 0 ||
 	    (so->so_state & SS_PROTOREF) || (so->so_qstate & SQ_COMP)) {
 		SOCK_UNLOCK(so);
-		ACCEPT_UNLOCK();
 		return;
 	}
 
-	head = so->so_head;
-	if (head != NULL) {
+	sol = so->so_listen;
+	if (sol != NULL) {
 		KASSERT((so->so_qstate & SQ_COMP) != 0 ||
 		    (so->so_qstate & SQ_INCOMP) != 0,
-		    ("sofree: so_head != NULL, but neither SQ_COMP nor "
+		    ("sofree: so_listen != NULL, but neither SQ_COMP nor "
 		    "SQ_INCOMP"));
 		KASSERT((so->so_qstate & SQ_COMP) == 0 ||
 		    (so->so_qstate & SQ_INCOMP) == 0,
 		    ("sofree: so->so_qstate is SQ_COMP and also SQ_INCOMP"));
-		TAILQ_REMOVE(&head->so_incomp, so, so_list);
-		head->so_incqlen--;
+		SOLISTEN_LOCK(sol);
+		TAILQ_REMOVE(&sol->sol_incomp, so, so_list);
+		sol->sol_incqlen--;
+		SOLISTEN_UNLOCK(sol);
 		so->so_qstate &= ~SQ_INCOMP;
-		so->so_head = NULL;
+		so->so_listen = NULL;
 	}
 	KASSERT((so->so_qstate & SQ_COMP) == 0 &&
 	    (so->so_qstate & SQ_INCOMP) == 0,
-	    ("sofree: so_head == NULL, but still SQ_COMP(%d) or SQ_INCOMP(%d)",
-	    so->so_qstate & SQ_COMP, so->so_qstate & SQ_INCOMP));
-	if (so->so_options & SO_ACCEPTCONN) {
-		KASSERT((TAILQ_EMPTY(&so->so_comp)),
-		    ("sofree: so_comp populated"));
-		KASSERT((TAILQ_EMPTY(&so->so_incomp)),
-		    ("sofree: so_incomp populated"));
-	}
+	    ("%s: so_listen == NULL, but still SQ_COMP(%d) or SQ_INCOMP(%d)",
+	    __func__, so->so_qstate & SQ_COMP, so->so_qstate & SQ_INCOMP));
 	SOCK_UNLOCK(so);
-	ACCEPT_UNLOCK();
 
 	VNET_SO_ASSERT(so);
-	if (pr->pr_flags & PR_RIGHTS && pr->pr_domain->dom_dispose != NULL)
-		(*pr->pr_domain->dom_dispose)(so);
-	if (pr->pr_usrreqs->pru_detach != NULL)
-		(*pr->pr_usrreqs->pru_detach)(so);
 
 	/*
+	 * If socket has pcb pointer cleared, this means we are
+	 * called from solisten() and pcb shall not be disposed
+	 * and detached.
+	 */
+	if (so->so_pcb != NULL) {
+		if (pr->pr_flags & PR_RIGHTS &&
+		    pr->pr_domain->dom_dispose != NULL)
+			(*pr->pr_domain->dom_dispose)(so);
+		if (pr->pr_usrreqs->pru_detach != NULL)
+			(*pr->pr_usrreqs->pru_detach)(so);
+	}
+
+	/*
 	 * From this point on, we assume that no other references to this
 	 * socket exist anywhere else in the stack.  Therefore, no locks need
 	 * to be acquired or held.
@@ -891,45 +1020,60 @@ soclose(struct socket *so)
 drop:
 	if (so->so_proto->pr_usrreqs->pru_close != NULL)
 		(*so->so_proto->pr_usrreqs->pru_close)(so);
-	ACCEPT_LOCK();
-	if (so->so_options & SO_ACCEPTCONN) {
-		struct socket *sp;
-		/*
-		 * Prevent new additions to the accept queues due
-		 * to ACCEPT_LOCK races while we are draining them.
-		 */
-		so->so_options &= ~SO_ACCEPTCONN;
-		while ((sp = TAILQ_FIRST(&so->so_incomp)) != NULL) {
-			TAILQ_REMOVE(&so->so_incomp, sp, so_list);
-			so->so_incqlen--;
-			sp->so_qstate &= ~SQ_INCOMP;
-			sp->so_head = NULL;
-			ACCEPT_UNLOCK();
-			soabort(sp);
-			ACCEPT_LOCK();
-		}
-		while ((sp = TAILQ_FIRST(&so->so_comp)) != NULL) {
-			TAILQ_REMOVE(&so->so_comp, sp, so_list);
-			so->so_qlen--;
-			sp->so_qstate &= ~SQ_COMP;
-			sp->so_head = NULL;
-			ACCEPT_UNLOCK();
-			soabort(sp);
-			ACCEPT_LOCK();
-		}
-		KASSERT((TAILQ_EMPTY(&so->so_comp)),
-		    ("%s: so_comp populated", __func__));
-		KASSERT((TAILQ_EMPTY(&so->so_incomp)),
-		    ("%s: so_incomp populated", __func__));
-	}
 	SOCK_LOCK(so);
 	KASSERT((so->so_state & SS_NOFDREF) == 0, ("soclose: NOFDREF"));
 	so->so_state |= SS_NOFDREF;
-	sorele(so);			/* NB: Returns with ACCEPT_UNLOCK(). */
+	sorele(so);
 	CURVNET_RESTORE();
 	return (error);
 }
 
+int
+solistenclose(struct solisten *sol)
+{
+	struct accept_queue comp, incomp;
+	struct socket *so;
+
+	KASSERT((sol->sol_state & SS_NOFDREF) == 0, ("%s: NOFDREF", __func__));
+
+	CURVNET_SET(sol->sol_vnet);
+	funsetown(&sol->sol_sigio);
+
+	if (sol->sol_accept_filter != NULL)
+		accept_filt_setopt(sol, NULL);
+
+	(*sol->sol_proto->pr_usrreqs->pru_listenclose)(sol);
+
+	TAILQ_INIT(&comp);
+	TAILQ_INIT(&incomp);
+	SOLISTEN_LOCK(sol);
+	TAILQ_SWAP(&comp, &sol->sol_comp, socket, so_list);
+	TAILQ_SWAP(&incomp, &sol->sol_incomp, socket, so_list);
+	sol->sol_incqlen = 0;
+	sol->sol_qlen = 0;
+	SOLISTEN_UNLOCK(sol);
+	while ((so = TAILQ_FIRST(&incomp)) != NULL) {
+		TAILQ_REMOVE(&incomp, so, so_list);
+		so->so_qstate &= ~SQ_INCOMP;
+		so->so_listen = NULL;
+		soabort(so);
+	}
+	while ((so = TAILQ_FIRST(&comp)) != NULL) {
+		TAILQ_REMOVE(&comp, so, so_list);
+		so->so_qstate &= ~SQ_COMP;
+		so->so_listen = NULL;
+		soabort(so);
+	}
+	seldrain(&sol->sol_selinfo);
+	knlist_destroy(&sol->sol_selinfo.si_note);
+	sol->sol_state |= SS_NOFDREF;
+	mtx_destroy(&sol->sol_mutex);
+	free(sol, M_SOLISTEN);
+	CURVNET_RESTORE();
+
+	return (0);
+}
+
 /*
  * soabort() is used to abruptly tear down a connection, such as when a
  * resource limit is reached (listen queue depth exceeded), or if a listen
@@ -963,7 +1107,6 @@ soabort(struct socket *so)
 
 	if (so->so_proto->pr_usrreqs->pru_abort != NULL)
 		(*so->so_proto->pr_usrreqs->pru_abort)(so);
-	ACCEPT_LOCK();
 	SOCK_LOCK(so);
 	sofree(so);
 }
@@ -996,9 +1139,6 @@ soconnectat(int fd, struct socket *so, struct sock
 {
 	int error;
 
-	if (so->so_options & SO_ACCEPTCONN)
-		return (EOPNOTSUPP);
-
 	CURVNET_SET(so->so_vnet);
 	/*
 	 * If protocol is connection-based, can only connect once.
@@ -2509,7 +2649,7 @@ sosetopt(struct socket *so, struct sockopt *sopt)
 	error = 0;
 	if (sopt->sopt_level != SOL_SOCKET) {
 		if (so->so_proto->pr_ctloutput != NULL) {
-			error = (*so->so_proto->pr_ctloutput)(so, sopt);
+			error = (*so->so_proto->pr_ctloutput)(so->so_pcb, sopt);
 			CURVNET_RESTORE();
 			return (error);
 		}
@@ -2516,12 +2656,6 @@ sosetopt(struct socket *so, struct sockopt *sopt)
 		error = ENOPROTOOPT;
 	} else {
 		switch (sopt->sopt_name) {
-		case SO_ACCEPTFILTER:
-			error = do_setopt_accept_filter(so, sopt);
-			if (error)
-				goto bad;
-			break;
-
 		case SO_LINGER:
 			error = sooptcopyin(sopt, &l, sizeof l, sizeof l);
 			if (error)
@@ -2716,7 +2850,7 @@ sosetopt(struct socket *so, struct sockopt *sopt)
 			break;
 		}
 		if (error == 0 && so->so_proto->pr_ctloutput != NULL)
-			(void)(*so->so_proto->pr_ctloutput)(so, sopt);
+			(void)(*so->so_proto->pr_ctloutput)(so->so_pcb, sopt);
 	}
 bad:
 	CURVNET_RESTORE();
@@ -2767,7 +2901,7 @@ sogetopt(struct socket *so, struct sockopt *sopt)
 	error = 0;
 	if (sopt->sopt_level != SOL_SOCKET) {
 		if (so->so_proto->pr_ctloutput != NULL)
-			error = (*so->so_proto->pr_ctloutput)(so, sopt);
+			error = (*so->so_proto->pr_ctloutput)(so->so_pcb, sopt);
 		else
 			error = ENOPROTOOPT;
 		CURVNET_RESTORE();
@@ -2775,7 +2909,7 @@ sogetopt(struct socket *so, struct sockopt *sopt)
 	} else {
 		switch (sopt->sopt_name) {
 		case SO_ACCEPTFILTER:
-			error = do_getopt_accept_filter(so, sopt);
+			error = EINVAL;
 			break;
 
 		case SO_LINGER:
@@ -2794,7 +2928,6 @@ sogetopt(struct socket *so, struct sockopt *sopt)
 		case SO_REUSEPORT:
 		case SO_BROADCAST:
 		case SO_OOBINLINE:
-		case SO_ACCEPTCONN:
 		case SO_TIMESTAMP:
 		case SO_BINTIME:
 		case SO_NOSIGPIPE:
@@ -2855,11 +2988,11 @@ integer:
 			error = sooptcopyin(sopt, &extmac, sizeof(extmac),
 			    sizeof(extmac));
 			if (error)
-				goto bad;
+				break;
 			error = mac_getsockopt_label(sopt->sopt_td->td_ucred,
 			    so, &extmac);
 			if (error)
-				goto bad;
+				break;
 			error = sooptcopyout(sopt, &extmac, sizeof extmac);
 #else
 			error = EOPNOTSUPP;
@@ -2875,7 +3008,7 @@ integer:
 			error = mac_getsockopt_peerlabel(
 			    sopt->sopt_td->td_ucred, so, &extmac);
 			if (error)
-				goto bad;
+				break;
 			error = sooptcopyout(sopt, &extmac, sizeof extmac);
 #else
 			error = EOPNOTSUPP;
@@ -2882,16 +3015,13 @@ integer:
 #endif
 			break;
 
+#if 0
+QQQ		case SO_ACCEPTCONN:
+#endif
 		case SO_LISTENQLIMIT:
-			optval = so->so_qlimit;
-			goto integer;
-
 		case SO_LISTENQLEN:
-			optval = so->so_qlen;
-			goto integer;
-
 		case SO_LISTENINCQLEN:
-			optval = so->so_incqlen;
+			optval = 0;
 			goto integer;
 
 		case SO_TS_CLOCK:
@@ -2911,14 +3041,81 @@ integer:
 			break;
 		}
 	}
-#ifdef MAC
-bad:
-#endif
 	CURVNET_RESTORE();
 	return (error);
 }
 
 int
+solgetopt(struct solisten *sol, struct sockopt *sopt)
+{
+	int optval, error;
+
+	CURVNET_SET(sol->sol_vnet);
+	if (sopt->sopt_level != SOL_SOCKET) {
+		if (sol->sol_proto->pr_ctloutput != NULL)
+			error = (*sol->sol_proto->pr_ctloutput)(sol->sol_pcb,
+			     sopt);
+		else
+			error = ENOPROTOOPT;
+		CURVNET_RESTORE();
+		return (error);
+	}
+
+	switch (sopt->sopt_name) {
+	case SO_ACCEPTFILTER:
+		error = accept_filt_getopt(sol, sopt);
+		break;
+
+	case SO_LISTENQLIMIT:
+		optval = sol->sol_qlimit;
+		goto integer;
+
+	case SO_LISTENQLEN:
+		optval = sol->sol_qlen;
+		goto integer;
+
+	case SO_LISTENINCQLEN:
+		optval = sol->sol_incqlen;
+integer:
+		error = sooptcopyout(sopt, &optval, sizeof optval);
+		break;
+
+	default:
+		error = ENOPROTOOPT;
+	}
+	CURVNET_RESTORE();
+	return (error);
+}
+
+int
+solsetopt(struct solisten *sol, struct sockopt *sopt)
+{
+	int error;
+
+	CURVNET_SET(sol->sol_vnet);
+	if (sopt->sopt_level != SOL_SOCKET) {
+		if (sol->sol_proto->pr_ctloutput != NULL)
+			error = (*sol->sol_proto->pr_ctloutput)(sol->sol_pcb,
+			    sopt);
+		else
+			error = ENOPROTOOPT;
+		CURVNET_RESTORE();
+		return (error);
+	}
+
+	switch (sopt->sopt_name) {
+	case SO_ACCEPTFILTER:
+		error = accept_filt_setopt(sol, sopt);
+		break;
+
+	default:
+		error = ENOPROTOOPT;
+	}
+	CURVNET_RESTORE();
+	return (error);
+}
+
+int
 soopt_getm(struct sockopt *sopt, struct mbuf **mp)
 {
 	struct mbuf *m, *m_prev;
@@ -3100,6 +3297,25 @@ sopoll_generic(struct socket *so, int events, stru
 }
 
 int
+solistenpoll(struct solisten *sol, int events, struct ucred *active_cred,
+    struct thread *td)
+{
+
+	if (!(events & (POLLIN | POLLRDNORM)))
+		return (0);
+
+	SOLISTEN_LOCK(sol);
+	if (!TAILQ_EMPTY(&sol->sol_comp)) {
+		SOLISTEN_UNLOCK(sol);
+		return (events & (POLLIN | POLLRDNORM));
+	} else {
+		selrecord(td, &sol->sol_selinfo);
+		SOLISTEN_UNLOCK(sol);
+		return (0);
+	}
+}
+
+int
 soo_kqfilter(struct file *fp, struct knote *kn)
 {
 	struct socket *so = kn->kn_fp->f_data;
@@ -3107,10 +3323,7 @@ soo_kqfilter(struct file *fp, struct knote *kn)
 
 	switch (kn->kn_filter) {
 	case EVFILT_READ:
-		if (so->so_options & SO_ACCEPTCONN)
-			kn->kn_fop = &solisten_filtops;
-		else
-			kn->kn_fop = &soread_filtops;
+		kn->kn_fop = &soread_filtops;
 		sb = &so->so_rcv;
 		break;
 	case EVFILT_WRITE:
@@ -3132,6 +3345,22 @@ soo_kqfilter(struct file *fp, struct knote *kn)
 	return (0);
 }
 
+int
+sol_kqfilter(struct file *fp, struct knote *kn)
+{
+	struct solisten *sol = kn->kn_fp->f_data;
+
+	if (kn->kn_filter != EVFILT_READ)
+		return (EINVAL);
+
+	kn->kn_fop = &solisten_filtops;
+	SOLISTEN_LOCK(sol);
+	knlist_add(&sol->sol_selinfo.si_note, kn, 1);
+	SOLISTEN_UNLOCK(sol);
+
+	return (0);
+}
+
 /*
  * Some routines that return EOPNOTSUPP for entry points that are not
  * supported by a protocol.  Fill in as needed.
@@ -3210,7 +3439,8 @@ pru_disconnect_notsupp(struct socket *so)
 }
 
 int
-pru_listen_notsupp(struct socket *so, int backlog, struct thread *td)
+pru_listen_notsupp(struct socket *so, struct solisten *sol, int backlog,
+    struct thread *td)
 {
 
 	return EOPNOTSUPP;
@@ -3314,6 +3544,16 @@ filt_sordetach(struct knote *kn)
 	SOCKBUF_UNLOCK(&so->so_rcv);
 }
 
+static void
+filt_soldetach(struct knote *kn)
+{
+	struct solisten *sol = kn->kn_fp->f_data;
+
+	SOLISTEN_LOCK(sol);
+	knlist_remove(&sol->sol_selinfo.si_note, kn, 1);
+	SOLISTEN_UNLOCK(sol);
+}
+
 /*ARGSUSED*/
 static int
 filt_soread(struct knote *kn, long hint)
@@ -3401,10 +3641,10 @@ filt_soempty(struct knote *kn, long hint)
 static int
 filt_solisten(struct knote *kn, long hint)
 {
-	struct socket *so = kn->kn_fp->f_data;
+	struct solisten *sol = kn->kn_fp->f_data;
 
-	kn->kn_data = so->so_qlen;
-	return (!TAILQ_EMPTY(&so->so_comp));
+	kn->kn_data = sol->sol_qlen;
+	return (!TAILQ_EMPTY(&sol->sol_comp));
 }
 
 int
@@ -3463,35 +3703,37 @@ soisconnecting(struct socket *so)
 void
 soisconnected(struct socket *so)
 {
-	struct socket *head;
+	struct solisten *sol;
 	int ret;
 
 restart:
-	ACCEPT_LOCK();
+	if ((sol = so->so_listen) != NULL)
+		SOLISTEN_LOCK(sol);
 	SOCK_LOCK(so);
 	so->so_state &= ~(SS_ISCONNECTING|SS_ISDISCONNECTING|SS_ISCONFIRMING);
 	so->so_state |= SS_ISCONNECTED;
-	head = so->so_head;
-	if (head != NULL && (so->so_qstate & SQ_INCOMP)) {
+	if (sol != NULL && (so->so_qstate & SQ_INCOMP)) {
 		if ((so->so_options & SO_ACCEPTFILTER) == 0) {
 			SOCK_UNLOCK(so);
-			TAILQ_REMOVE(&head->so_incomp, so, so_list);
-			head->so_incqlen--;
+			TAILQ_REMOVE(&sol->sol_incomp, so, so_list);
+			sol->sol_incqlen--;
 			so->so_qstate &= ~SQ_INCOMP;
-			TAILQ_INSERT_TAIL(&head->so_comp, so, so_list);
-			head->so_qlen++;
+			TAILQ_INSERT_TAIL(&sol->sol_comp, so, so_list);
+			sol->sol_qlen++;
 			so->so_qstate |= SQ_COMP;
-			ACCEPT_UNLOCK();
-			sorwakeup(head);
-			wakeup_one(&head->so_timeo);
+			/* QQQ sorwakeup(sol); */
+			selwakeuppri(&sol->sol_selinfo, PSOCK);
+			KNOTE_LOCKED(&sol->sol_selinfo.si_note, 0);
+			SOLISTEN_UNLOCK(sol);
+			wakeup_one(&sol->sol_comp);
 		} else {
-			ACCEPT_UNLOCK();
+			SOLISTEN_UNLOCK(sol);
 			soupcall_set(so, SO_RCV,
-			    head->so_accf->so_accept_filter->accf_callback,
-			    head->so_accf->so_accept_filter_arg);
+			    sol->sol_accept_filter->accf_callback,
+			    sol->sol_accept_filter_arg);
 			so->so_options &= ~SO_ACCEPTFILTER;
-			ret = head->so_accf->so_accept_filter->accf_callback(so,
-			    head->so_accf->so_accept_filter_arg, M_NOWAIT);
+			ret = sol->sol_accept_filter->accf_callback(so,
+			    sol->sol_accept_filter_arg, M_NOWAIT);
 			if (ret == SU_ISCONNECTED)
 				soupcall_clear(so, SO_RCV);
 			SOCK_UNLOCK(so);
@@ -3500,8 +3742,9 @@ restart:
 		}
 		return;
 	}
+	if (sol != NULL)
+		SOLISTEN_UNLOCK(sol);
 	SOCK_UNLOCK(so);
-	ACCEPT_UNLOCK();
 	wakeup(&so->so_timeo);
 	sorwakeup(so);
 	sowwakeup(so);
@@ -3628,9 +3871,7 @@ sotoxsocket(struct socket *so, struct xsocket *xso
 	xso->so_pcb = so->so_pcb;
 	xso->xso_protocol = so->so_proto->pr_protocol;
 	xso->xso_family = so->so_proto->pr_domain->dom_family;
-	xso->so_qlen = so->so_qlen;
-	xso->so_incqlen = so->so_incqlen;
-	xso->so_qlimit = so->so_qlimit;
+	xso->so_qlen = xso->so_incqlen = xso->so_qlimit = 0;
 	xso->so_timeo = so->so_timeo;
 	xso->so_error = so->so_error;
 	xso->so_pgid = so->so_sigio ? so->so_sigio->sio_pgid : 0;
@@ -3640,20 +3881,33 @@ sotoxsocket(struct socket *so, struct xsocket *xso
 	xso->so_uid = so->so_cred->cr_uid;
 }
 
-
 /*
- * Socket accessor functions to provide external consumers with
- * a safe interface to socket state
- *
+ * Create an external-format (``xsocket'') structure using the information in
+ * the listening socket structure pointed to by sol.
  */
-
 void
-so_listeners_apply_all(struct socket *so, void (*func)(struct socket *, void *),
-    void *arg)
+soltoxsocket(struct solisten *sol, struct xsocket *xso)
 {
 
-	TAILQ_FOREACH(so, &so->so_comp, so_list)
-		func(so, arg);
+	xso->xso_len = sizeof *xso;
+	xso->xso_so = (struct socket *)sol;
+	xso->so_type = sol->sol_type;
+	xso->so_options = sol->sol_options /* QQQ | SO_ACCEPTCON */ ;
+	xso->so_linger = sol->sol_linger;
+	xso->so_state = sol->sol_state;
+	xso->so_pcb = sol->sol_pcb;
+	xso->xso_protocol = sol->sol_proto->pr_protocol;
+	xso->xso_family = sol->sol_proto->pr_domain->dom_family;
+	xso->so_qlen = sol->sol_qlen;
+	xso->so_incqlen = sol->sol_incqlen;
+	xso->so_qlimit = sol->sol_qlimit;
+	xso->so_timeo = 0;
+	xso->so_error = sol->sol_error;
+	xso->so_pgid = sol->sol_sigio ? sol->sol_sigio->sio_pgid : 0;
+	xso->so_oobmark = 0;
+	bzero(&xso->so_snd, sizeof(xso->so_snd));
+	bzero(&xso->so_rcv, sizeof(xso->so_rcv));
+	xso->so_uid = sol->sol_cred->cr_uid;
 }
 
 struct sockbuf *
